/// <reference types="knockout" />
import { UiElement, UiElementOptions } from "./uiElement";
export interface ChildrensElementOptions<TChild extends UiElement> extends UiElementOptions {
    children?: Array<TChild> | KnockoutObservableArray<TChild>;
}
export declare abstract class ChildrensElement<TChild extends UiElement> extends UiElement {
    protected constructor(tagName: string, type: string, options?: ChildrensElementOptions<TChild>);
    private renderChildren;
    protected build(): void;
    protected options: ChildrensElementOptions<TChild>;
    getChildren(): Array<TChild>;
    setChildren(children: Array<TChild>): void;
    addChild(newChild: TChild, referenceChild?: TChild): void;
    removeChild(element: TChild): void;
    clear(): void;
}
